SystemOrganization addCategory: #MorphExamplesAndDemos!

TextMorph subclass: #ClipboardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!ClipboardMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'Clipboard'
		categories: #('Useful' )
		documentation: 'This object will always show whatever is on the text clipboard'! !

!ClipboardMorph methodsFor: 'initialization' stamp: ''!
defaultBorderColor
	^ Color
		r: 1.0
		g: 0.355
		b: 0.452! !

!ClipboardMorph methodsFor: 'initialization' stamp: ''!
defaultBorderWidth
	^ 6! !

!ClipboardMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color blue! !

!ClipboardMorph methodsFor: 'parts bin' stamp: ''!
initialize
	super initialize.
	self extent: 250 @ 200.
	self
		backgroundColor: (Color
				r: 0.484
				g: 1.0
				b: 0.484).
	self setBalloonText: 'This shows the current contents of the text clipboard'.
	self newContents: Clipboard clipboardText! !

!ClipboardMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	self newContents: Clipboard clipboardText! !

!ClipboardMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 1000! !

!ClipboardMorph methodsFor: 'testing' stamp: ''!
wantsSteps
	^ true! !

EllipseMorph subclass: #AtomMorph
	instanceVariableNames: 'velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!AtomMorph class methodsFor: 'examples' stamp: ''!
example
	| a |
	a := AtomMorph new openInWorld.
	a color: Color random.
	[1000
		timesRepeat: [a bounceIn: World bounds.
			(Delay forMilliseconds: 50) wait].
	a delete] fork! !

!AtomMorph class methodsFor: 'new-morph participation' stamp: ''!
includeInNewMorphMenu
	^ false! !

!AtomMorph methodsFor: 'private' stamp: ''!
bounceIn: aRect 
	| p vx vy px py bounced |
	p := self position.
	vx := velocity x.
	vy := velocity y.
	px := p x + vx.
	py := p y + vy.
	bounced := false.
	px > aRect right
		ifTrue: [px := aRect right - (px - aRect right).
			vx := velocity x negated.
			bounced := true].
	py > aRect bottom
		ifTrue: [py := aRect bottom - (py - aRect bottom).
			vy := velocity y negated.
			bounced := true].
	px < aRect left
		ifTrue: [px := aRect left - (px - aRect left).
			vx := velocity x negated.
			bounced := true].
	py < aRect top
		ifTrue: [py := aRect top - (py - aRect top).
			vy := velocity y negated.
			bounced := true].
	self position: px @ py.
	bounced
		ifTrue: [self velocity: vx @ vy].
	^ bounced! !

!AtomMorph methodsFor: 'initialization' stamp: ''!
defaultBorderWidth
	^ 0! !

!AtomMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color blue! !

!AtomMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	| drawAsRect |
	drawAsRect := false.
	drawAsRect
		ifTrue: [aCanvas fillRectangle: self bounds color: color]
		ifFalse: [super drawOn: aCanvas]! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
infected
	^ color = Color red! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
infected: aBoolean 
	aBoolean
		ifTrue: [self color: Color red]
		ifFalse: [self color: Color blue]! !

!AtomMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self extent: 8 @ 7.
	self
		randomPositionIn: (0 @ 0 corner: 300 @ 300)
		maxVelocity: 10! !

!AtomMorph methodsFor: 'initialization' stamp: ''!
randomPositionIn: aRectangle maxVelocity: maxVelocity 
	| origin extent |
	origin := aRectangle origin.
	extent := (aRectangle extent - self bounds extent) rounded.
	self position: origin x + extent x atRandom @ (origin y + extent y atRandom).
	velocity := maxVelocity - (2 * maxVelocity) atRandom @ (maxVelocity - (2 * maxVelocity) atRandom)! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
step
	self color: Color random! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
stepTime
	^ 1000! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
velocity
	^ velocity! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
velocity: newVelocity 
	velocity := newVelocity! !

EllipseMorph subclass: #CrossMorph
	instanceVariableNames: 'velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!CrossMorph class methodsFor: 'examples' stamp: ''!
example
	| a |
	a := AtomMorph new openInWorld.
	a color: Color random.
	[1000
		timesRepeat: [a bounceIn: World bounds.
			(Delay forMilliseconds: 50) wait].
	a delete] fork! !

!CrossMorph class methodsFor: 'new-morph participation' stamp: ''!
includeInNewMorphMenu
	^ false! !

!CrossMorph methodsFor: 'private' stamp: ''!
bounceIn: aRect 
	| p vx vy px py bounced |
	p := self position.
	vx := velocity x.
	vy := velocity y.
	px := p x + vx.
	py := p y + vy.
	bounced := false.
	px > aRect right
		ifTrue: [px := aRect right - (px - aRect right).
			vx := velocity x negated.
			bounced := true].
	py > aRect bottom
		ifTrue: [py := aRect bottom - (py - aRect bottom).
			vy := velocity y negated.
			bounced := true].
	px < aRect left
		ifTrue: [px := aRect left - (px - aRect left).
			vx := velocity x negated.
			bounced := true].
	py < aRect top
		ifTrue: [py := aRect top - (py - aRect top).
			vy := velocity y negated.
			bounced := true].
	self position: px @ py.
	bounced
		ifTrue: [self velocity: vx @ vy].
	^ bounced! !

!CrossMorph methodsFor: 'initialization' stamp: ''!
defaultBorderWidth
	^ 0! !

!CrossMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color blue! !

!CrossMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	| crossHeight crossWidth horizontalBar verticalBar |
	crossHeight := self height / 3.0.
	crossWidth := self width / 3.0.
	horizontalBar := self bounds insetBy: 0 @ crossHeight.
	verticalBar := self bounds insetBy: crossWidth @ 0.
	aCanvas fillRectangle: horizontalBar color: self color.
	aCanvas fillRectangle: verticalBar color: self color! !

!CrossMorph methodsFor: 'accessing' stamp: ''!
infected
	^ color = Color red! !

!CrossMorph methodsFor: 'accessing' stamp: ''!
infected: aBoolean 
	aBoolean
		ifTrue: [self color: Color red]
		ifFalse: [self color: Color blue]! !

!CrossMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self extent: 30 @ 30.
	self
		randomPositionIn: (0 @ 0 corner: 300 @ 300)
		maxVelocity: 5! !

!CrossMorph methodsFor: 'initialization' stamp: ''!
randomPositionIn: aRectangle maxVelocity: maxVelocity 
	| origin extent |
	origin := aRectangle origin.
	extent := (aRectangle extent - self bounds extent) rounded.
	self position: origin x + extent x atRandom @ (origin y + extent y atRandom).
	velocity := maxVelocity - (2 * maxVelocity) atRandom @ (maxVelocity - (2 * maxVelocity) atRandom)! !

!CrossMorph methodsFor: 'accessing' stamp: ''!
step
	self color: Color random! !

!CrossMorph methodsFor: 'accessing' stamp: ''!
stepTime
	^ 1000! !

!CrossMorph methodsFor: 'accessing' stamp: ''!
velocity
	^ velocity! !

!CrossMorph methodsFor: 'accessing' stamp: ''!
velocity: newVelocity 
	velocity := newVelocity! !

EllipseMorph subclass: #Flasher
	instanceVariableNames: 'onColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!Flasher class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'Flasher'
		categories: #('Demo' )
		documentation: 'A circle that flashes'! !

!Flasher methodsFor: 'parts bin' stamp: ''!
initializeToStandAlone
	super initializeToStandAlone.
	self color: Color red.
	self onColor: Color red.
	self borderWidth: 2.
	self extent: 25 @ 25! !

!Flasher methodsFor: 'operations' stamp: ''!
onColor
	^ onColor
		ifNil: [onColor := Color red]! !

!Flasher methodsFor: 'operations' stamp: ''!
onColor: aColor 
	onColor := aColor.
	self color: aColor! !

!Flasher methodsFor: 'stepping and presenter' stamp: ''!
step
	super step.
	self color = self onColor
		ifTrue: [self
				color: (onColor alphaMixed: 0.5 with: Color black)]
		ifFalse: [self color: onColor]! !

!Flasher methodsFor: 'testing' stamp: ''!
stepTime
	^ 500! !

EllipseMorph subclass: #MovingEyeMorph
	instanceVariableNames: 'inner iris'
	classVariableNames: 'IrisSize'
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!MovingEyeMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'MovingEye'
		categories: #('Demo' )
		documentation: 'An eye which follows the cursor'! !

!MovingEyeMorph class methodsFor: 'initialization' stamp: ''!
initialize
	IrisSize := 0.42 @ 0.5! !

!MovingEyeMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color black! !

!MovingEyeMorph methodsFor: 'geometry' stamp: ''!
extent: aPoint 
	super extent: aPoint.
	inner extent: (self extent * (1.0 @ 1.0 - IrisSize)) asIntegerPoint.
	iris extent: (self extent * IrisSize) asIntegerPoint.
	inner position: (self center - (inner extent // 2)) asIntegerPoint! !

!MovingEyeMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	inner := EllipseMorph new.
	inner color: self color.
	inner extent: (self extent * (1.0 @ 1.0 - IrisSize)) asIntegerPoint.
	inner borderColor: self color.
	inner borderWidth: 0.
	iris := EllipseMorph new.
	iris color: Color white.
	iris extent: (self extent * IrisSize) asIntegerPoint.
	self addMorphCentered: inner.
	inner addMorphCentered: iris.
	self extent: 26 @ 33! !

!MovingEyeMorph methodsFor: 'as yet unclassified' stamp: ''!
irisPos: cp 
	| a b theta x y |
	theta := (cp - self center) theta.
	a := inner width // 2.
	b := inner height // 2.
	x := a * theta cos.
	y := b * theta sin.
	iris position: (x @ y) asIntegerPoint + self center - (iris extent // 2)! !

!MovingEyeMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	| cp |
	cp := self globalPointToLocal: World primaryHand position.
	(inner containsPoint: cp)
		ifTrue: [iris position: cp - (iris extent // 2)]
		ifFalse: [self irisPos: cp].
	self changed! !

!MovingEyeMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 100! !

EllipseMorph subclass: #WatchMorph
	instanceVariableNames: 'fontName cColor handsColor romanNumerals antialias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!WatchMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'Watch'
		categories: #('Useful' )
		documentation: 'An analog clock face'! !

!WatchMorph class methodsFor: 'as yet unclassified' stamp: ''!
fontName: aString bgColor: aColor centerColor: otherColor 
	^ self new fontName: aString;
		 color: aColor;
		 centerColor: otherColor! !

!WatchMorph methodsFor: 'menus' stamp: ''!
addCustomMenuItems: aMenu hand: aHandMorph 
	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu addUpdating: #romanNumeralString action: #toggleRoman.
	aMenu addUpdating: #antiAliasString action: #toggleAntialias.
	aMenu addLine.
	aMenu add: 'change font...' translated action: #changeFont.
	aMenu balloonTextForLastItem: 'Allows you to change the font used to display the numbers.' translated.
	aMenu balloonTextForLastItem: 'Allows you to specify a new color for the hands of the watch.  Note that actual *watch* color can be changed simply by using the halo''s recoloring handle.' translated.
	aMenu balloonTextForLastItem: 'Allows you to specify a new color to be used during PM hours for the center portion of the watch; during AM hours, a lighter shade of the same color will be used.' translated! !

!WatchMorph methodsFor: 'menus' stamp: ''!
antiAliasString
	^ (antialias
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'anti-aliasing' translated! !

!WatchMorph methodsFor: 'accessing' stamp: ''!
antialias: aBoolean 
	antialias := aBoolean! !

!WatchMorph methodsFor: 'accessing' stamp: ''!
centerColor: aColor 
	cColor := aColor
				ifNil: [Color transparent]! !

!WatchMorph methodsFor: 'menus' stamp: ''!
changeFont
	| choice |
	choice := UIManager default chooseFrom: StrikeFont familyNames values: StrikeFont familyNames.
	choice
		ifNotNil: [self fontName: choice]! !

!WatchMorph methodsFor: 'labels' stamp: ''!
createLabels
	| numeral font h r |
	self removeAllMorphs.
	font := StrikeFont familyName: fontName size: (h := self height min: self width) // 8.
	r := 1.0 - (1.4 * font height / h).
	1
		to: 12
		do: [:hour | 
			numeral := romanNumerals
						ifTrue: [#('I' 'II' 'III' 'IV' 'V' 'VI' 'VII' ' VIII' 'IX' 'X' 'XI' 'XII' ) at: hour]
						ifFalse: [hour asString].
			self addMorphBack: ((StringMorph
					contents: numeral
					font: font
					emphasis: 1)
					center: (self radius: r hourAngle: hour)) lock]! !

!WatchMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color green! !

!WatchMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	| pHour pMin pSec time centerColor |
	time := Time now.
	pHour := self radius: 0.6 hourAngle: time hours + (time minutes / 60.0).
	pMin := self radius: 0.72 hourAngle: time minutes / 5.0.
	pSec := self radius: 0.8 hourAngle: time seconds / 5.0.
	centerColor := cColor
				ifNil: [Color transparent]
				ifNotNil: [time hours < 12
						ifTrue: [cColor muchLighter]
						ifFalse: [cColor]].
	antialias
		ifTrue: [aCanvas asBalloonCanvas aaLevel: 4;
				
				drawOval: (bounds insetBy: borderWidth // 2 + 1)
				color: self fillStyle
				borderWidth: borderWidth
				borderColor: borderColor;
				
				drawOval: (bounds insetBy: self extent * 0.35)
				color: centerColor
				borderWidth: 0
				borderColor: Color black;
				
				drawPolygon: {self center. pHour}
				color: Color transparent
				borderWidth: 3
				borderColor: handsColor;
				
				drawPolygon: {self center. pMin}
				color: Color transparent
				borderWidth: 2
				borderColor: handsColor;
				
				drawPolygon: {self center. pSec}
				color: Color transparent
				borderWidth: 1
				borderColor: handsColor]
		ifFalse: [super drawOn: aCanvas.
			aCanvas
				fillOval: (bounds insetBy: self extent * 0.35)
				color: centerColor;
				
				line: self center
				to: pHour
				width: 3
				color: handsColor;
				
				line: self center
				to: pMin
				width: 2
				color: handsColor;
				
				line: self center
				to: pSec
				width: 1
				color: handsColor]! !

!WatchMorph methodsFor: 'geometry' stamp: ''!
extent: newExtent 
	super extent: newExtent.
	self createLabels! !

!WatchMorph methodsFor: 'accessing' stamp: ''!
fontName: aString 
	fontName := aString.
	self createLabels! !

!WatchMorph methodsFor: 'accessing' stamp: ''!
handsColor: aColor 
	handsColor := aColor! !

!WatchMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self handsColor: Color red.
	self centerColor: Color gray.
	romanNumerals := false.
	antialias := false.
	fontName := 'NewYork'.
	self extent: 130 @ 130.
	self start! !

!WatchMorph methodsFor: 'private' stamp: ''!
radius: unitRadius hourAngle: hourAngle 
	^ self center + (self extent
			* (Point r: 0.5 * unitRadius degrees: hourAngle * 30.0 - 90.0))! !

!WatchMorph methodsFor: 'menus' stamp: ''!
romanNumeralString
	^ (romanNumerals
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'roman numerals' translated! !

!WatchMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	self changed! !

!WatchMorph methodsFor: 'menus' stamp: ''!
toggleAntialias
	antialias := antialias not! !

!WatchMorph methodsFor: 'menus' stamp: ''!
toggleRoman
	romanNumerals := romanNumerals not.
	self createLabels! !

RectangleMorph subclass: #DoubleClickExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!DoubleClickExample class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'DoubleClick'
		categories: #('Demo' )
		documentation: 'An example of how to use double-click in moprhic'! !

!DoubleClickExample methodsFor: 'accessing' stamp: ''!
balloonText
	^ 'Double-click on me to change my color; 
single-click on me to change border color;
hold mouse down within me and then move it to grow 
(if I''m red) or shrink (if I''m blue).' translated! !

!DoubleClickExample methodsFor: 'event handling' stamp: ''!
click: evt 
	self showBalloon: 'click' hand: evt hand.
	self
		borderColor: (self borderColor = Color black
				ifTrue: [Color yellow]
				ifFalse: [Color black])! !

!DoubleClickExample methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color red! !

!DoubleClickExample methodsFor: 'event handling' stamp: ''!
doubleClick: evt 
	self showBalloon: 'doubleClick' hand: evt hand.
	self
		color: (color = Color blue
				ifTrue: [Color red]
				ifFalse: [Color blue])! !

!DoubleClickExample methodsFor: 'event handling' stamp: ''!
handlesMouseDown: evt 
	^ true! !

!DoubleClickExample methodsFor: 'event handling' stamp: ''!
mouseDown: evt 
	evt hand waitForClicksOrDrag: self event: evt! !

!DoubleClickExample methodsFor: 'event handling' stamp: ''!
startDrag: evt 
	| oldCenter |
	evt isMouseDown
		ifTrue: [self showBalloon: 'drag (mouse down)' hand: evt hand.
			self world displayWorld.
			(Delay forMilliseconds: 750) wait].
	evt isMouseUp
		ifTrue: [self showBalloon: 'drag (mouse up)' hand: evt hand].
	(evt isMouseUp
			or: [evt isMouseDown])
		ifFalse: [self showBalloon: 'drag (mouse still down)' hand: evt hand].
	(self containsPoint: evt cursorPoint)
		ifFalse: [^ self].
	oldCenter := self center.
	color = Color red
		ifTrue: [self extent: self extent + (1 @ 1)]
		ifFalse: [self
				extent: (self extent - (1 @ 1) max: 16 @ 16)].
	self center: oldCenter! !

RectangleMorph subclass: #HeadingMorph
	instanceVariableNames: 'degrees magnitude'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!HeadingMorph methodsFor: 'initialization' stamp: ''!
defaultBorderWidth
	^ 1! !

!HeadingMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color
		r: 0.6
		g: 1.0
		b: 1.0! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
degrees
	^ degrees + 90.0 \\ 360.0! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
degrees: aNumber 
	degrees := aNumber asFloat + 270.0 \\ 360.0! !

!HeadingMorph methodsFor: 'drawing' stamp: ''!
drawArrowFrom: p1 to: p2 width: w color: aColor on: aCanvas 
	| d p |
	d := (p1 - p2) theta radiansToDegrees.
	aCanvas
		line: p1
		to: p2
		width: w
		color: aColor.
	p := p2
				+ (Point r: 5 degrees: d - 50).
	aCanvas
		line: p
		to: p2
		width: w
		color: aColor.
	p := p2
				+ (Point r: 5 degrees: d + 50).
	aCanvas
		line: p
		to: p2
		width: w
		color: aColor! !

!HeadingMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	| x y r center box |
	super drawOn: aCanvas.
	box := self innerBounds.
	1
		to: 9
		do: [:i | 
			x := box left + (box width * i // 10).
			aCanvas
				line: x @ box top
				to: x @ (box bottom - 1)
				color: Color black.
			y := box top + (box height * i // 10).
			aCanvas
				line: box left @ y
				to: box right - 1 @ y
				color: Color black].
	r := box width asFloat * magnitude asFloat / 2.0 - 1.0.
	center := box center.
	self
		drawArrowFrom: center - (1 @ 1)
		to: center + (r * degrees degreesToRadians cos @ 0) - (1 @ 1)
		width: 3
		color: Color red
		on: aCanvas.
	self
		drawArrowFrom: center - (1 @ 1)
		to: center + (0 @ (r * degrees degreesToRadians sin)) - (1 @ 1)
		width: 3
		color: Color red
		on: aCanvas.
	self
		drawArrowFrom: center - (1 @ 1)
		to: center
				+ (Point r: r degrees: degrees) - (1 @ 1)
		width: 3
		color: Color black
		on: aCanvas! !

!HeadingMorph methodsFor: 'geometry' stamp: ''!
extent: aPoint 
	| d |
	d := aPoint x min: aPoint y.
	super extent: d @ d! !

!HeadingMorph methodsFor: 'event handling' stamp: ''!
handlesMouseDown: evt 
	^ true! !

!HeadingMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	degrees := 90.0.
	magnitude := 1.0.
	self extent: 160 @ 160! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
magnitude
	^ magnitude! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
magnitude: aNumber 
	magnitude := (aNumber asFloat max: 0.0)
				min: 1.0! !

!HeadingMorph methodsFor: 'events' stamp: ''!
mouseDown: evt 
	| v |
	self changed.
	v := evt cursorPoint - bounds center.
	degrees := v theta radiansToDegrees.
	magnitude := v r asFloat / (bounds width asFloat / 2.0) min: 1.0! !

!HeadingMorph methodsFor: 'events' stamp: ''!
mouseMove: evt 
	self mouseDown: evt! !

RectangleMorph subclass: #StarWithABallMorph
	instanceVariableNames: 'phase ball star'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!StarWithABallMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	phase := 1.
	self extent: 200 @ 200.
	ball := EllipseMorph new extent: 30 @ 30.
	self
		addMorph: ((star := StarMorph new extent: 150 @ 150) center: self center)! !

!StarWithABallMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	phase := phase \\ 8 + 1.
	phase = 1
		ifTrue: [^ ball delete].
	phase < 4
		ifTrue: [^ self].
	phase = 4
		ifTrue: [self addMorph: ball].
	ball
		align: ball center
		with: (star vertices at: phase - 3 * 2)! !

RectangleMorph subclass: #StickyPadMorph
	instanceVariableNames: ''
	classVariableNames: 'Colors LastColorIndex'
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!StickyPadMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'Sticky Pad'
		categories: #('Graphics' )
		documentation: 'A translucent, borderless rectangle of a standard size, delivered in a predictable sequence of pastel colors'
		sampleImageForm: (Form
				extent: 50 @ 40
				depth: 16
				fromArray: #(1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1389318863 1389318863 1389318863 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521903284 1389318863 1389318863 1389317938 1460426508 1460426508 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1723098804 1389318863 1389318863 1328697138 1460426508 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521903284 1723098804 1389318863 1389317938 1328697138 1460426508 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1723098804 1723098804 1389318863 1328697138 1328697138 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521903284 1723098804 1723098804 1389317938 1328697138 1328697138 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1723098804 1723098804 1723098804 1328697138 1328697138 1328697138 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461414680 1723098804 1723098804 1723096921 1328697138 1328697138 1328702226 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1796762392 1723098804 1723098804 1599692633 1328697138 1328697138 1662149394 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461414680 1796762392 1723098804 1723096921 1599692633 1328697138 1328702226 1662149394 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1796762392 1796762392 1723098804 1599692633 1599692633 1328697138 1662149394 1662149394 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461414680 1796762392 1796762392 1723096921 1599692633 1599692633 1328702226 1662149394 1662149394 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 )
				offset: 0 @ 0)! !

!StickyPadMorph class methodsFor: 'initialization' stamp: ''!
initialize
	LastColorIndex := 0.
	Colors := {TranslucentColor
				r: 0.0
				g: 0.0
				b: 0.839
				alpha: 0.267. TranslucentColor
				r: 0.484
				g: 1.0
				b: 0.452
				alpha: 0.706. TranslucentColor
				r: 1.0
				g: 0.355
				b: 0.71
				alpha: 0.569. TranslucentColor
				r: 1.0
				g: 1.0
				b: 0.03
				alpha: 0.561. TranslucentColor
				r: 0.484
				g: 0.161
				b: 1.0
				alpha: 0.529. TranslucentColor
				r: 0.097
				g: 0.097
				b: 0.097
				alpha: 0.192}.
	self registerInFlapsRegistry! !

!StickyPadMorph class methodsFor: 'as yet unclassified' stamp: ''!
registerInFlapsRegistry
	self environment
		at: #Flaps
		ifPresent: [:cl | 
			cl registerQuad: #(#StickyPadMorph #newStandAlone 'Sticky Pad' 'Each time you obtain one of these pastel, translucent, borderless rectangles, it will be a different color from the previous time.' ) forFlapNamed: 'Supplies'.
			cl registerQuad: #(#StickyPadMorph #newStandAlone 'Sticky Pad' 'Each time you obtain one of these pastel, translucent, borderless rectangles, it will be a different color from the previous time.' ) forFlapNamed: 'PlugIn Supplies']! !

!StickyPadMorph methodsFor: 'visual properties' stamp: ''!
canHaveFillStyles
	^ true! !

!StickyPadMorph methodsFor: 'parts bin' stamp: ''!
initialize
	Colors
		ifNil: [self class initialize].
	LastColorIndex := LastColorIndex
				ifNil: [1]
				ifNotNil: [LastColorIndex \\ Colors size + 1].
	super initialize.
	self assureExternalName.
	self
		color: (Colors at: LastColorIndex).
	self extent: 200 @ 160.
	self borderWidth: 0! !

PolygonMorph subclass: #StarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!StarMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'Star'
		categories: #('Graphics' )
		documentation: 'A symmetrical polygon in the shape of a star'! !

!StarMorph class methodsFor: 'initialization' stamp: ''!
initialize
	self registerInFlapsRegistry! !

!StarMorph class methodsFor: 'initialization' stamp: ''!
registerInFlapsRegistry
	self environment
		at: #Flaps
		ifPresent: [:cl | 
			cl registerQuad: #(#StarMorph #authoringPrototype 'Star' 'A star' ) forFlapNamed: 'PlugIn Supplies'.
			cl registerQuad: #(#StarMorph #authoringPrototype 'Star' 'A star' ) forFlapNamed: 'Supplies']! !

!StarMorph class methodsFor: 'initialization' stamp: ''!
unload
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!StarMorph methodsFor: 'menu' stamp: ''!
addChangeSidesMenuItems: aCustomMenu hand: aHandMorph 
	aCustomMenu addLine.
	aCustomMenu add: 'more sides' translated action: #moreVertices.
	aCustomMenu add: 'fewer sides' translated action: #lessVertices! !

!StarMorph methodsFor: 'menu' stamp: ''!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self addChangeSidesMenuItems: aCustomMenu hand: aHandMorph.
	self addTwinkleMenuItems: aCustomMenu hand: aHandMorph! !

!StarMorph methodsFor: 'editing' stamp: ''!
addHandles
	self addStarHandles! !

!StarMorph methodsFor: 'editing' stamp: ''!
addStarHandles
	| center |
	self removeHandles.
	self insureCompatability.
	handles := OrderedCollection new.
	center := vertices average rounded.
	self withCenterOuterHandles; withUpDownLeftRightHandlesAround: 6 center: center.
	self placeHandles.
	self changed! !

!StarMorph methodsFor: 'menu' stamp: ''!
addTwinkleMenuItems: aCustomMenu hand: aHandMorph 
	aCustomMenu addLine.
	aCustomMenu add: 'twinkle fatter' translated action: #nextTwinkle.
	aCustomMenu add: 'twinkle thinner' translated action: #prevTwinkle! !

!StarMorph methodsFor: 'editing' stamp: ''!
changeVertices: label event: evt fromHandle: handle 
	label == #more
		ifTrue: [evt shiftPressed
				ifTrue: [self moreVertices]
				ifFalse: [self moreVertices]].
	label == #less
		ifTrue: [evt shiftPressed
				ifTrue: [self lessVertices]
				ifFalse: [self lessVertices]].
	label == #next
		ifTrue: [evt shiftPressed
				ifTrue: [self makeVertices: vertices size starRatio: self nextSkip]
				ifFalse: [self makeVertices: vertices size starRatio: self nextTwinkleSkip]].
	label == #prev
		ifTrue: [evt shiftPressed
				ifTrue: [self makeVertices: vertices size starRatio: self prevSkip]
				ifFalse: [self makeVertices: vertices size starRatio: self prevTwinkleSkip]].
	self computeBounds! !

!StarMorph methodsFor: 'initialization' stamp: ''!
defaultBorderColor
	^ Color black! !

!StarMorph methodsFor: 'initialization' stamp: ''!
defaultBorderWidth
	^ 1! !

!StarMorph methodsFor: 'initialization' stamp: ''!
defaultCenter
	^ 0 asPoint! !

!StarMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color lightBlue! !

!StarMorph methodsFor: 'initialization' stamp: ''!
defaultFirstVertex
	^ 10 asPoint! !

!StarMorph methodsFor: 'initialization' stamp: ''!
defaultSides
	^ 10! !

!StarMorph methodsFor: 'initialization' stamp: ''!
defaultStarRatio
	^ 5.0 / 12.0! !

!StarMorph methodsFor: 'editing' stamp: ''!
dragVertex: label event: evt fromHandle: handle 
	| center r1 rN a1 rTotal rNext |
	label == #outside
		ifTrue: [center := handles second center.
			r1 := center dist: vertices first.
			rN := r1
						min: (center dist: vertices last).
			rNext := 1
						max: (center dist: evt cursorPoint).
			a1 := 270.0
						+ (center bearingToPoint: evt cursorPoint).
			rTotal := vertices size even
						ifTrue: [evt shiftPressed
								ifTrue: [rNext + rNext min: rNext + rN]
								ifFalse: [r1 + rN * rNext / r1]]
						ifFalse: [rNext + rNext].
			rNext := rTotal - rNext.
			vertices := (a1 to: a1 + 359.999 by: 360.0 / vertices size)
						collect: [:angle | center
								+ (Point r: (rNext := rTotal - rNext) degrees: angle)].
			handle align: handle center with: evt cursorPoint].
	label == #center
		ifTrue: [evt shiftPressed
				ifTrue: [self updateFormFromUser]
				ifFalse: [self position: self position + (evt cursorPoint - handle center)]].
	self computeBounds! !

!StarMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self
		makeVertices: self defaultSides
		starRatio: self defaultStarRatio
		withCenter: self defaultCenter
		withPoint: self defaultFirstVertex.
	self computeBounds! !

!StarMorph methodsFor: 'parts bin' stamp: ''!
initializeToStandAlone
	^ self initialize removeHandles! !

!StarMorph methodsFor: 'initialization' stamp: ''!
insureCompatability
	| c v1 v2 |
	c := vertices average rounded.
	v1 := vertices first.
	v2 := vertices second.
	(c dist: v1)
			+ 0.001
			< (c dist: v2)
		ifTrue: [vertices := vertices allButFirst copyWith: v1]! !

!StarMorph methodsFor: 'menus' stamp: ''!
lessVertices
	| nVerts |
	(nVerts := 2 negated + vertices size) < 3
		ifFalse: [self makeVertices: nVerts]! !

!StarMorph methodsFor: 'initialization' stamp: ''!
makeVertices: nSides 
	| center r1 rN a1 rTotal rNext |
	center := vertices average rounded.
	r1 := center dist: vertices first.
	rN := center dist: vertices last.
	rNext := 1 max: r1.
	a1 := 270.0
				+ (center bearingToPoint: vertices first).
	rTotal := nSides even
				ifTrue: [rNext + rNext min: rNext + rN]
				ifFalse: [rNext + rNext].
	rNext := rTotal - rNext.
	self changed.
	vertices := (a1 to: a1 + 359.999 by: 360.0 / nSides)
				collect: [:angle | center
						+ (Point r: (rNext := rTotal - rNext) degrees: angle)].
	self computeBounds.
	self changed! !

!StarMorph methodsFor: 'initialization' stamp: ''!
makeVertices: nSides starRatio: fraction 
	| center r1 rN a1 rTotal rNext |
	center := vertices average rounded.
	r1 := center dist: vertices first.
	rNext := 1 max: r1.
	rN := (1.0 min: fraction)
				* rNext.
	a1 := 270.0
				+ (center bearingToPoint: vertices first).
	rTotal := nSides even
				ifTrue: [rNext + rNext min: rNext + rN]
				ifFalse: [rNext + rNext].
	rNext := rTotal - rNext.
	self changed.
	vertices := (a1 to: a1 + 359.999 by: 360.0 / nSides)
				collect: [:angle | center
						+ (Point r: (rNext := rTotal - rNext) degrees: angle)].
	self computeBounds.
	self changed! !

!StarMorph methodsFor: 'initialization' stamp: ''!
makeVertices: nSides starRatio: fraction withCenter: center withPoint: aPoint 
	| r1 rN a1 rTotal rNext |
	r1 := center dist: aPoint.
	rNext := 1 max: r1.
	rN := (1.0 min: fraction)
				* rNext.
	a1 := 270.0
				+ (center bearingToPoint: aPoint).
	rTotal := nSides even
				ifTrue: [rNext + rNext min: rNext + rN]
				ifFalse: [rNext + rNext].
	rNext := rTotal - rNext.
	self changed.
	vertices := (a1 to: a1 + 359.999 by: 360.0 / nSides)
				collect: [:angle | center
						+ (Point r: (rNext := rTotal - rNext) degrees: angle)].
	self computeBounds.
	self changed! !

!StarMorph methodsFor: 'menus' stamp: ''!
moreVertices
	self makeVertices: 2 + vertices size! !

!StarMorph methodsFor: 'geometry' stamp: ''!
nextSkip
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := (c dist: vertices first) truncated asFloat.
	rN := c dist: vertices last.
	skips := self skipRatios.
	n := skips * r1
				findFirst: [:r | r > (rN + 1.0)].
	^ skips atWrap: n! !

!StarMorph methodsFor: 'menus' stamp: ''!
nextTwinkle
	self makeVertices: vertices size starRatio: self nextTwinkleSkip.
	self computeBounds! !

!StarMorph methodsFor: 'geometry' stamp: ''!
nextTwinkleSkip
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := (c dist: vertices first) truncated asFloat.
	rN := c dist: vertices last.
	skips := self skipRatios.
	n := skips * r1
				findFirst: [:r | r > (rN + 1.0)].
	n = 0
		ifTrue: [n := 1].
	^ skips atWrap: n! !

!StarMorph methodsFor: 'menu' stamp: ''!
oneLessVertex
	self
		makeVertices: (3 max: 1 negated + vertices size)! !

!StarMorph methodsFor: 'menu' stamp: ''!
oneMoreVertex
	self makeVertices: 1 + vertices size! !

!StarMorph methodsFor: 'editing' stamp: ''!
placeHandles
	handles
		reverseDo: [:each | self addMorphFront: each]! !

!StarMorph methodsFor: 'geometry' stamp: ''!
prevSkip
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := c dist: vertices first.
	rN := (c dist: vertices last) truncated asFloat.
	skips := self skipRatios.
	n := skips * r1
				findLast: [:r | r + 1.0 < rN].
	n = 0
		ifTrue: [n := 1].
	^ skips at: n! !

!StarMorph methodsFor: 'menus' stamp: ''!
prevTwinkle
	self makeVertices: vertices size starRatio: self prevTwinkleSkip.
	self computeBounds! !

!StarMorph methodsFor: 'geometry' stamp: ''!
prevTwinkleSkip
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := c dist: vertices first.
	rN := (c dist: vertices last) truncated asFloat.
	skips := self skipRatios.
	n := skips * r1
				findLast: [:r | r + 1.0 < rN].
	^ skips atWrap: n! !

!StarMorph methodsFor: 'access' stamp: ''!
skipRatios
	| n alpha |
	n := vertices size.
	n odd
		ifTrue: [^ #(1.0 )].
	alpha := Float pi / (n // 2) asFloat.
	^ ((((Float halfPi - alpha to: alpha / 2.0 by: alpha negated)
		collect: [:angle | angle sin / (angle + alpha) sin])
		copyWith: 0.0)
		copyWithFirst: 1.0) reversed! !

!StarMorph methodsFor: 'access' stamp: ''!
starRatio
	| r c |
	c := vertices average rounded.
	r := (c dist: vertices last)
				/ (c dist: vertices first).
	^ r > 1.0
		ifTrue: [r reciprocal]
		ifFalse: [r]! !

!StarMorph methodsFor: 'accessing' stamp: ''!
starRatio: r 
	self
		makeVertices: vertices size
		starRatio: (r > 1.0
				ifTrue: [r reciprocal]
				ifFalse: [r])! !

!StarMorph methodsFor: 'menus' stamp: ''!
updateFormFromUser
	^ self! !

!StarMorph methodsFor: 'editing' stamp: ''!
updateHandles
	^ self! !

!StarMorph methodsFor: 'editing' stamp: ''!
withCenterOuterHandles
	| center v1 hExtent holder |
	center := vertices average rounded.
	hExtent := 8 @ 8.
	v1 := vertices first.
	holder := {(EllipseMorph
				newBounds: (Rectangle center: v1 extent: hExtent)
				color: Color yellow)
				setBalloonText: 'Move me to adjust size. Shift move to adjust pointiness'. (EllipseMorph
				newBounds: (Rectangle center: center extent: hExtent)
				color: Color yellow)
				setBalloonText: 'Move me to adjust position'}.
	holder
		with: {#outside. #center}
		do: [:handle :which | handle
				on: #mouseDown
				send: #dragVertex:event:fromHandle:
				to: self
				withValue: which;
				
				on: #mouseMove
				send: #dragVertex:event:fromHandle:
				to: self
				withValue: which].
	handles addAll: holder! !

!StarMorph methodsFor: 'editing' stamp: ''!
withUpDownLeftRightHandlesAround: radius center: center 
	| tri above holder triAbove triBelow triRight triLeft |
	above := 0 @ radius negated.
	tri := Array
				with: 0 @ -5
				with: 4 @ 3
				with: -4 @ 3.
	triAbove := tri + (center + above).
	triBelow := triAbove
				collect: [:pt | pt rotateBy: #pi centerAt: center].
	triRight := triAbove
				collect: [:pt | pt rotateBy: #right centerAt: center].
	triLeft := triAbove
				collect: [:pt | pt rotateBy: #left centerAt: center].
	holder := {(PolygonMorph
				vertices: triAbove
				color: Color green
				borderWidth: 1
				borderColor: Color black)
				setBalloonText: 'More points.'. (PolygonMorph
				vertices: triBelow
				color: Color magenta
				borderWidth: 1
				borderColor: Color black)
				setBalloonText: 'Fewer points.'. (PolygonMorph
				vertices: triRight
				color: Color green
				borderWidth: 1
				borderColor: Color black)
				setBalloonText: 'Twinkle fatter.'. (PolygonMorph
				vertices: triLeft
				color: Color magenta
				borderWidth: 1
				borderColor: Color black)
				setBalloonText: 'Twinkle thinner.'}.
	holder
		with: {#more. #less. #next. #prev}
		do: [:handle :which | handle
				on: #mouseDown
				send: #changeVertices:event:fromHandle:
				to: self
				withValue: which;
				
				on: #mouseMove
				send: #changeVertices:event:fromHandle:
				to: self
				withValue: which].
	^ handles addAll: holder! !

StringMorph subclass: #ClockMorph
	instanceVariableNames: 'showSeconds show24hr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!ClockMorph class methodsFor: 'scripting' stamp: ''!
authoringPrototype
	^ super authoringPrototype contents: Time now printString! !

!ClockMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'Clock'
		categories: #('Useful' )
		documentation: 'A digital clock'! !

!ClockMorph class methodsFor: 'initialization' stamp: ''!
initialize
	self registerInFlapsRegistry! !

!ClockMorph class methodsFor: 'initialization' stamp: ''!
registerInFlapsRegistry
	self environment
		at: #Flaps
		ifPresent: [:cl | 
			cl registerQuad: #(#ClockMorph #authoringPrototype 'Clock' 'A simple digital clock' ) forFlapNamed: 'Supplies'.
			cl registerQuad: #(#ClockMorph #authoringPrototype 'Clock' 'A simple digital clock' ) forFlapNamed: 'PlugIn Supplies']! !

!ClockMorph class methodsFor: 'initialization' stamp: ''!
unload
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!ClockMorph methodsFor: 'menu' stamp: ''!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	| item |
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	item := showSeconds
				ifTrue: ['stop showing seconds']
				ifFalse: ['start showing seconds'].
	aCustomMenu
		add: item translated
		target: self
		action: #toggleShowingSeconds.
	item := show24hr
				ifTrue: ['display Am/Pm']
				ifFalse: ['display 24 hour'].
	aCustomMenu
		add: item translated
		target: self
		action: #toggleShowing24hr! !

!ClockMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	showSeconds := true.
	show24hr := false.
	self step! !

!ClockMorph methodsFor: 'parts bin' stamp: ''!
initializeToStandAlone
	super initializeToStandAlone.
	showSeconds := true.
	self step! !

!ClockMorph methodsFor: '24hr' stamp: ''!
show24hr: aBoolean 
	show24hr := aBoolean! !

!ClockMorph methodsFor: 'seconds' stamp: ''!
showSeconds: aBoolean 
	showSeconds := aBoolean! !

!ClockMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	| time |
	super step.
	time := String
				streamContents: [:aStrm | Time now
						print24: show24hr
						showSeconds: showSeconds
						on: aStrm].
	self contents: time! !

!ClockMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 1000! !

!ClockMorph methodsFor: '24hr' stamp: ''!
toggleShowing24hr
	show24hr := show24hr not! !

!ClockMorph methodsFor: 'seconds' stamp: ''!
toggleShowingSeconds
	showSeconds := showSeconds not! !

StringMorph subclass: #FrameRateMorph
	instanceVariableNames: 'lastDisplayTime framesSinceLastDisplay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!FrameRateMorph class methodsFor: 'scripting' stamp: ''!
authoringPrototype
	| aMorph |
	aMorph := self new.
	aMorph color: Color blue.
	aMorph step.
	^ aMorph! !

!FrameRateMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'FrameRate'
		categories: #('Useful' )
		documentation: 'A readout that allows you to monitor the frame rate of your system'! !

!FrameRateMorph class methodsFor: 'initialization' stamp: ''!
initialize
	self registerInFlapsRegistry! !

!FrameRateMorph class methodsFor: 'initialization' stamp: ''!
registerInFlapsRegistry
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(#FrameRateMorph #authoringPrototype 'Frame Rate' 'An indicator of how fast your system is running' ) forFlapNamed: 'Widgets']! !

!FrameRateMorph class methodsFor: 'initialization' stamp: ''!
unload
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!FrameRateMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	lastDisplayTime := 0.
	framesSinceLastDisplay := 0! !

!FrameRateMorph methodsFor: 'parts bin' stamp: ''!
initializeToStandAlone
	super initializeToStandAlone.
	self color: Color blue.
	self step! !

!FrameRateMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	| now mSecs mSecsPerFrame framesPerSec newContents |
	framesSinceLastDisplay := framesSinceLastDisplay + 1.
	now := Time millisecondClockValue.
	mSecs := now - lastDisplayTime.
	(mSecs > 500
			or: [mSecs < 0])
		ifTrue: [mSecsPerFrame := mSecs // framesSinceLastDisplay.
			framesPerSec := framesSinceLastDisplay * 1000 // mSecs.
			newContents := mSecsPerFrame printString , ' mSecs (' , framesPerSec printString , ' frame'
						, (framesPerSec == 1
								ifTrue: ['']
								ifFalse: ['s']) , '/sec)'.
			self contents: newContents.
			lastDisplayTime := now.
			framesSinceLastDisplay := 0]! !

!FrameRateMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 0! !

StringMorph subclass: #InfoStringMorph
	instanceVariableNames: 'stepTime block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!InfoStringMorph class methodsFor: 'instance creation' stamp: ''!
on: aBlock 
	^ self new block: aBlock! !

!InfoStringMorph methodsFor: 'accessing' stamp: ''!
block
	^ block! !

!InfoStringMorph methodsFor: 'accessing' stamp: ''!
block: aBlock 
	block := aBlock! !

!InfoStringMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	stepTime := 1000.
	block := [Time now]! !

!InfoStringMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	self contents: block value asString! !

!InfoStringMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ stepTime! !

!InfoStringMorph methodsFor: 'accessing' stamp: ''!
stepTime: anInteger 
	stepTime := anInteger! !

BorderedMorph subclass: #MagnifierMorph
	instanceVariableNames: 'magnification trackPointer srcExtent showPointer'
	classVariableNames: 'RecursionLock'
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

MagnifierMorph subclass: #FishEyeMorph
	instanceVariableNames: 'gridNum d clipRects toRects quads savedExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!FishEyeMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'FishEye'
		categories: #('Useful' )
		documentation: 'An extreme-wide-angle lens'! !

!FishEyeMorph methodsFor: 'initialization' stamp: ''!
calculateTransform
	| stepX stepY rect tx ty arrayX arrayY |
	(gridNum x = 0
			or: [gridNum y = 0])
		ifTrue: [^ self].
	stepX := srcExtent x // gridNum x.
	stepY := srcExtent y // gridNum y.
	arrayX := (1 to: gridNum y + 1)
				collect: [:j | FloatArray new: gridNum x + 1].
	arrayY := (1 to: gridNum y + 1)
				collect: [:j | FloatArray new: gridNum x + 1].
	0
		to: gridNum y
		do: [:j | 0
				to: gridNum x
				do: [:i | 
					(arrayX at: j + 1)
						at: i + 1
						put: i * stepX.
					(arrayY at: j + 1)
						at: i + 1
						put: j * stepY]].
	0
		to: gridNum y
		do: [:j | 
			self
				transformX: (arrayX at: j + 1).
			self
				transformY: (arrayY at: j + 1)].
	0
		to: gridNum y
		do: [:j | 
			arrayX
				at: j + 1
				put: ((1 to: gridNum x + 1)
						collect: [:i | ((arrayX at: j + 1)
								at: i) asInteger]).
			arrayY
				at: j + 1
				put: ((1 to: gridNum x + 1)
						collect: [:i | ((arrayY at: j + 1)
								at: i) asInteger])].
	clipRects := (1 to: gridNum y)
				collect: [:j | Array new: gridNum x].
	toRects := (1 to: gridNum y)
				collect: [:j | Array new: gridNum x].
	quads := (1 to: gridNum y)
				collect: [:j | Array new: gridNum x].
	0
		to: gridNum y - 1
		do: [:j | 0
				to: gridNum x - 1
				do: [:i | 
					rect := ((arrayX at: j + 1)
								at: i + 1)
								@ ((arrayY at: j + 1)
										at: i + 1) corner: ((arrayX at: j + 2)
									at: i + 2)
									@ ((arrayY at: j + 2)
											at: i + 2).
					(clipRects at: j + 1)
						at: i + 1
						put: rect.
					rect width >= stepX
						ifTrue: [rect := rect expandBy: 1 @ 0].
					rect height >= stepY
						ifTrue: [rect := rect expandBy: 0 @ 1].
					(toRects at: j + 1)
						at: i + 1
						put: rect.
					tx := i * stepX.
					ty := j * stepY.
					(quads at: j + 1)
						at: i + 1
						put: {tx @ ty. tx @ (ty + stepY). tx + stepX @ (ty + stepY). tx + stepX @ ty}]]! !

!FishEyeMorph methodsFor: 'menus' stamp: ''!
chooseMagnification
	self inform: 'Magnification is fixed, sorry.' translated! !

!FishEyeMorph methodsFor: 'menu' stamp: ''!
chooseMagnification: evt 
	^ self! !

!FishEyeMorph methodsFor: 'geometry' stamp: ''!
extent: aPoint 
	| g gridSize |
	gridSize := self gridSizeFor: aPoint.
	g := aPoint - (2 * borderWidth) // gridSize.
	srcExtent := g * gridSize.
	gridNum := g.
	^ super extent: self defaultExtent! !

!FishEyeMorph methodsFor: 'initialization' stamp: ''!
g: aFloatArray max: max focus: focus 
	| dNormX array |
	dNormX := aFloatArray - focus.
	array := dNormX / max.
	array *= d.
	array += 1.0.
	array := 1.0 / array.
	dNormX *= (d + 1.0).
	array *= dNormX.
	^ array += focus! !

!FishEyeMorph methodsFor: 'private' stamp: ''!
gridSizeFor: aPoint 
	| g |
	g := aPoint x min: aPoint y.
	g <= 256
		ifTrue: [^ 8].
	^ 16! !

!FishEyeMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	magnification := 1.
	d := 1.3.
	self extent: 130 @ 130! !

!FishEyeMorph methodsFor: 'parts bin' stamp: ''!
initializeToStandAlone
	super initializeToStandAlone.
	magnification := 1.
	d := 1.3.
	self extent: 130 @ 130! !

!FishEyeMorph methodsFor: 'magnifying' stamp: ''!
magnifiedForm
	| warp warpForm fromForm |
	savedExtent ~= srcExtent
		ifTrue: [savedExtent := srcExtent.
			self calculateTransform].
	warpForm := Form extent: srcExtent depth: Display depth.
	fromForm := super magnifiedForm.
	warp := (WarpBlt current toForm: warpForm) sourceForm: fromForm;
				 colorMap: nil;
				 cellSize: 2;
				 combinationRule: Form over.
	1
		to: gridNum y
		do: [:j | 1
				to: gridNum x
				do: [:i | warp
						clipRect: ((clipRects at: j)
								at: i);
						
						copyQuad: ((quads at: j)
								at: i)
						toRect: ((toRects at: j)
								at: i)]].
	^ warpForm! !

!FishEyeMorph methodsFor: 'initialization' stamp: ''!
transformX: aFloatArray 
	| focus gridNum2 subArray dMaxX |
	focus := srcExtent x asFloat / 2.
	gridNum2 := (aFloatArray
				findFirst: [:x | x > focus])
				- 1.
	dMaxX := 0.0 - focus.
	subArray := self
				g: (aFloatArray copyFrom: 1 to: gridNum2)
				max: dMaxX
				focus: focus.
	aFloatArray
		replaceFrom: 1
		to: gridNum2
		with: subArray
		startingAt: 1.
	dMaxX := focus.
	subArray := self
				g: (aFloatArray copyFrom: gridNum2 + 1 to: gridNum x + 1)
				max: dMaxX
				focus: focus.
	aFloatArray
		replaceFrom: gridNum2 + 1
		to: gridNum x + 1
		with: subArray
		startingAt: 1! !

!FishEyeMorph methodsFor: 'initialization' stamp: ''!
transformY: aFloatArray 
	| focus subArray dMaxY |
	focus := srcExtent y asFloat / 2.
	dMaxY := aFloatArray first <= focus
				ifTrue: [0.0 - focus]
				ifFalse: [focus].
	subArray := self
				g: (aFloatArray copyFrom: 1 to: gridNum x + 1)
				max: dMaxY
				focus: focus.
	aFloatArray
		replaceFrom: 1
		to: gridNum x + 1
		with: subArray
		startingAt: 1! !

!MagnifierMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'Magnifier'
		categories: #('Useful' )
		documentation: 'A magnifying glass'! !

!MagnifierMorph class methodsFor: 'instance creation' stamp: ''!
newShowingPointer
	^ self new showPointer: true;
		 setNameTo: 'HandMagnifier';
		 yourself! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine; add: 'magnification...' translated action: #chooseMagnification; addUpdating: #trackingPointerString action: #toggleTrackingPointer; addUpdating: #showingPointerString action: #toggleShowingPointer! !

!MagnifierMorph methodsFor: 'accessing' stamp: ''!
borderWidth: anInteger 
	| c |
	c := self center.
	super borderWidth: anInteger.
	super extent: self defaultExtent.
	self center: c! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
chooseMagnification
	| result possibleMagnifications title |
	possibleMagnifications := #(1.5 2 4 8 ).
	title := 'Choose magnification' translated , '\(' , 'currently' translated , ' {1})' format: {magnification}.
	result := UIManager default
				chooseFrom: possibleMagnifications
				values: possibleMagnifications
				title: title.
	(result isNil
			or: [result = magnification])
		ifTrue: [^ self].
	magnification := result.
	self extent: self extent.
	self changed! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
chooseMagnification: evt 
	| handle origin aHand currentMag |
	currentMag := magnification.
	aHand := evt
				ifNil: [self currentHand]
				ifNotNil: [evt hand].
	origin := aHand position y.
	handle := HandleMorph new
				forEachPointDo: [:newPoint | self magnification: newPoint y - origin / 8.0 + currentMag].
	aHand attachMorph: handle.
	handle startStepping.
	self changed! !

!MagnifierMorph methodsFor: 'initialization' stamp: ''!
defaultBorderWidth
	^ 1! !

!MagnifierMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color black! !

!MagnifierMorph methodsFor: 'geometry' stamp: ''!
defaultExtent
	^ (srcExtent * magnification) truncated + (2 * borderWidth)! !

!MagnifierMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	super drawOn: aCanvas.
	aCanvas isShadowDrawing
		ifFalse: [aCanvas paintImage: self magnifiedForm at: self innerBounds origin]! !

!MagnifierMorph methodsFor: 'geometry' stamp: ''!
extent: aPoint 
	srcExtent := aPoint - (2 * borderWidth) // magnification.
	^ super extent: self defaultExtent! !

!MagnifierMorph methodsFor: 'event handling' stamp: ''!
handlesMouseDown: evt 
	^ evt yellowButtonPressed
		or: [super handlesMouseDown: evt]! !

!MagnifierMorph methodsFor: 'accessing' stamp: ''!
hasTranslucentColor
	^ self sourceRect intersects: self bounds! !

!MagnifierMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	trackPointer := true.
	showPointer := false.
	magnification := 2.
	self extent: 128 @ 128! !

!MagnifierMorph methodsFor: 'magnifying' stamp: ''!
magnification: aNumber 
	| c |
	magnification := aNumber min: 8 max: 0.5.
	magnification := magnification
				roundTo: (magnification < 3
						ifTrue: [0.5]
						ifFalse: [1]).
	srcExtent := srcExtent min: 512 @ 512 // magnification.
	c := self center.
	super extent: self defaultExtent.
	self center: c! !

!MagnifierMorph methodsFor: 'magnifying' stamp: ''!
magnifiedForm
	| srcRect form magnified |
	srcRect := self sourceRectFrom: self sourcePoint.
	(RecursionLock isNil
			and: [self showPointer
					or: [srcRect intersects: self bounds]])
		ifTrue: [RecursionLock := self.
			form := self currentWorld
						patchAt: srcRect
						without: self
						andNothingAbove: false.
			RecursionLock := nil]
		ifFalse: [form := Display copy: srcRect].
	magnified := form
				magnify: form boundingBox
				by: magnification
				smoothing: (magnification isInteger
						ifTrue: [1]
						ifFalse: [2]).
	self showPointer
		ifTrue: [magnified
				reverse: (magnified center - (2 @ 2) extent: 4 @ 4)
				fillColor: Color white].
	^ magnified! !

!MagnifierMorph methodsFor: 'event handling' stamp: ''!
mouseDown: evt 
	evt yellowButtonPressed
		ifTrue: [self chooseMagnification: evt]
		ifFalse: [super mouseDown: evt]! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
showPointer
	^ showPointer
		ifNil: [showPointer := false]! !

!MagnifierMorph methodsFor: 'accessing' stamp: ''!
showPointer: aBoolean 
	showPointer == aBoolean
		ifTrue: [^ self].
	showPointer := aBoolean.
	self changed! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
showingPointerString
	^ (self showPointer
		ifTrue: ['stop showing pointer']
		ifFalse: ['start showing pointer']) translated! !

!MagnifierMorph methodsFor: 'magnifying' stamp: ''!
sourcePoint
	^ (trackPointer not
			or: [owner notNil
					and: [owner isHandMorph]])
		ifTrue: [self center]
		ifFalse: [self currentHand position]! !

!MagnifierMorph methodsFor: 'magnifying' stamp: ''!
sourceRect
	^ self sourceRectFrom: self sourcePoint! !

!MagnifierMorph methodsFor: 'magnifying' stamp: ''!
sourceRectFrom: aPoint 
	^ (aPoint extent: srcExtent)
		translateBy: srcExtent // -2 + 1! !

!MagnifierMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	self changed! !

!MagnifierMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 0! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
toggleShowingPointer
	self showPointer: self showPointer not! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
toggleTrackingPointer
	trackPointer := trackPointer not! !

!MagnifierMorph methodsFor: 'menu' stamp: ''!
trackingPointerString
	^ (trackPointer
		ifTrue: ['stop tracking pointer']
		ifFalse: ['start tracking pointer']) translated! !

ImageMorph subclass: #AnimatedImageMorph
	instanceVariableNames: 'images delays stepTime nextTime imageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!AnimatedImageMorph class methodsFor: 'filein/out' stamp: ''!
fileReaderServicesForFile: fullName suffix: suffix 
	^ ((AnimatedGIFReadWriter typicalFileExtensions asSet add: '*';
			 add: 'form';
			 yourself) includes: suffix)
		ifTrue: [self services]
		ifFalse: [#()]! !

!AnimatedImageMorph class methodsFor: 'instance creation' stamp: ''!
fromGIFFileNamed: fileName 
	| reader |
	reader := AnimatedGIFReadWriter formsFromFileNamed: fileName.
	^ reader forms size = 1
		ifTrue: [ImageMorph new image: reader forms first]
		ifFalse: [self new fromReader: reader]! !

!AnimatedImageMorph class methodsFor: 'instance creation' stamp: ''!
fromStream: aStream 
	| reader |
	reader := AnimatedGIFReadWriter formsFromStream: aStream.
	^ reader forms size = 1
		ifTrue: [ImageMorph new image: reader forms first]
		ifFalse: [self new fromReader: reader]! !

!AnimatedImageMorph class methodsFor: 'initialization' stamp: ''!
initialize
	self environment
		at: #FileList
		ifPresent: [:cl | cl registerFileReader: self]! !

!AnimatedImageMorph class methodsFor: 'instance creation' stamp: ''!
openGIFInWindow: aStream 
	^ (self fromStream: aStream binary) openInWorld! !

!AnimatedImageMorph class methodsFor: 'filein/out' stamp: ''!
serviceOpenGIFInWindow
	^ (SimpleServiceEntry
		provider: self
		label: 'open the graphic as a morph'
		selector: #openGIFInWindow:
		description: 'open a GIF graphic file as a morph'
		buttonLabel: 'open')
		argumentGetter: [:fileList | fileList readOnlyStream]! !

!AnimatedImageMorph class methodsFor: 'filein/out' stamp: ''!
services
	^ Array with: self serviceOpenGIFInWindow with: Form serviceImageAsBackground! !

!AnimatedImageMorph class methodsFor: 'initialization' stamp: ''!
unload
	self environment
		at: #FileList
		ifPresent: [:cl | cl unregisterFileReader: self]! !

!AnimatedImageMorph methodsFor: 'private' stamp: ''!
fromGIFFileNamed: fileName 
	self
		fromReader: (AnimatedGIFReadWriter formsFromFileNamed: fileName)! !

!AnimatedImageMorph methodsFor: 'private' stamp: ''!
fromReader: reader 
	images := reader forms.
	delays := reader delays.
	imageIndex := 0.
	self
		image: (Form extent: images first extent depth: 32).
	self step! !

!AnimatedImageMorph methodsFor: 'private' stamp: ''!
fromStream: aStream 
	self
		fromReader: (AnimatedGIFReadWriter formsFromStream: aStream)! !

!AnimatedImageMorph methodsFor: 'private' stamp: ''!
images
	^ images! !

!AnimatedImageMorph methodsFor: 'private' stamp: ''!
initialize
	nextTime := Time millisecondClockValue.
	imageIndex := 1.
	stepTime := 10.
	super initialize! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	| d |
	images isEmpty
		ifTrue: [^ self].
	nextTime > Time millisecondClockValue
		ifTrue: [^ self].
	self changed.
	self
		image: (images at: (imageIndex := imageIndex \\ images size + 1)).
	self changed.
	d := (delays at: imageIndex)
				ifNil: [0].
	nextTime := Time millisecondClockValue + d! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: ''!
stepTime
	^ stepTime
		ifNil: [super stepTime]! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: ''!
stepTime: anInteger 
	stepTime := anInteger! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: ''!
wantsSteps
	^ images size > 1! !

ImageMorph subclass: #ImageMorphWithSpotlight
	instanceVariableNames: 'spotImage spotShape spotBuffer spotOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!ImageMorphWithSpotlight class methodsFor: 'example' stamp: ''!
example1
	(self new image: Form fromUser) openInWorld! !

!ImageMorphWithSpotlight methodsFor: 'all' stamp: ''!
backgroundImage: bkgndImage spotImage: anImage spotShape: formOfDepth1 
	spotImage := anImage.
	spotShape := formOfDepth1.
	spotBuffer := Form extent: spotShape extent depth: spotImage depth.
	super image: bkgndImage.
	spotOn := false! !

!ImageMorphWithSpotlight methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	super drawOn: aCanvas.
	spotOn
		ifTrue: [aCanvas paintImage: spotBuffer at: spotBuffer offset]! !

!ImageMorphWithSpotlight methodsFor: 'accessing' stamp: ''!
image: anImage 
	self
		backgroundImage: anImage asGrayScale
		spotImage: anImage
		spotShape: (Form dotOfSize: 100)! !

!ImageMorphWithSpotlight methodsFor: 'all' stamp: ''!
spotChanged
	self
		invalidRect: (spotBuffer offset extent: spotBuffer extent)! !

!ImageMorphWithSpotlight methodsFor: 'stepping and presenter' stamp: ''!
step
	| cp |
	((self bounds expandBy: spotBuffer extent // 2)
			containsPoint: (cp := self cursorPoint))
		ifTrue: [cp - (spotBuffer extent // 2) = spotBuffer offset
				ifTrue: [^ self].
			spotOn := true.
			self spotChanged.
			spotBuffer offset: cp - (spotBuffer extent // 2).
			self spotChanged.
			(BitBlt current toForm: spotBuffer)
				fill: spotBuffer boundingBox
				fillColor: (Bitmap with: 0)
				rule: Form over;
				
				clipRect: (spotBuffer boundingBox
						intersect: (self bounds translateBy: spotBuffer offset negated));
				
				copyForm: spotImage
				to: self position - spotBuffer offset
				rule: Form over;
				
				copyForm: spotShape
				to: spotShape offset negated
				rule: Form and
				colorMap: (Bitmap with: 0 with: 4294967295)]
		ifFalse: [spotOn
				ifTrue: [self spotChanged.
					spotOn := false]]! !

!ImageMorphWithSpotlight methodsFor: 'testing' stamp: ''!
stepTime
	^ 20! !

Morph subclass: #BackgroundMorph
	instanceVariableNames: 'image offset delta running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!BackgroundMorph class methodsFor: 'as yet unclassified' stamp: ''!
test
	^ (BackgroundMorph new
		addMorph: (ImageMorph new image: Form fromUser)) openInWorld! !

!BackgroundMorph methodsFor: 'menus' stamp: ''!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	running
		ifTrue: [aCustomMenu add: 'stop' translated action: #stopRunning]
		ifFalse: [aCustomMenu add: 'start' translated action: #startRunning]! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
delta
	^ delta! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
delta: aPoint 
	delta := aPoint! !

!BackgroundMorph methodsFor: 'layout' stamp: ''!
fullBounds
	^ self bounds! !

!BackgroundMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	offset := 0 @ 0.
	delta := 1 @ 0.
	running := true! !

!BackgroundMorph methodsFor: 'layout' stamp: ''!
layoutChanged
	^ self! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
offset
	^ offset! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
offset: aPoint 
	offset := aPoint! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
slideBy: inc 
	submorphs isEmpty
		ifTrue: [^ self].
	offset := offset + inc \\ self subBounds extent.
	self changed! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
startRunning
	running := true.
	self changed! !

!BackgroundMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	running
		ifTrue: [self slideBy: delta]! !

!BackgroundMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 20! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
stopRunning
	running := false.
	self changed! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
subBounds
	| subBounds |
	subBounds := nil.
	self
		submorphsDo: [:m | subBounds := subBounds isNil
						ifTrue: [m fullBounds]
						ifFalse: [subBounds merge: m fullBounds]].
	^ subBounds! !

Morph subclass: #BouncingAtomsMorph
	instanceVariableNames: 'damageReported infectionHistory transmitInfection recentTemperatures temperature temps tempsAtom ndAtom validAtom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!BouncingAtomsMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'BouncingAtoms'
		categories: #('Demo' )
		documentation: 'The original, intensively-optimized bouncing-atoms simulation by John Maloney'! !

!BouncingAtomsMorph class methodsFor: 'initialization' stamp: ''!
initialize
	self registerInFlapsRegistry! !

!BouncingAtomsMorph class methodsFor: 'initialization' stamp: ''!
registerInFlapsRegistry
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(#BouncingAtomsMorph #new 'Bouncing Atoms' 'Atoms, mate' ) forFlapNamed: 'Widgets']! !

!BouncingAtomsMorph class methodsFor: 'initialization' stamp: ''!
unload
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!BouncingAtomsMorph methodsFor: 'other' stamp: ''!
addAtoms: n 
	| a |
	n
		timesRepeat: [a := AtomMorph new.
			a randomPositionIn: bounds maxVelocity: 10.
			self addMorph: a]! !

!BouncingAtomsMorph methodsFor: 'drawing' stamp: ''!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'startInfection' translated action: #startInfection.
	aCustomMenu add: 'set atom count' translated action: #setAtomCount.
	aCustomMenu add: 'show infection history' translated action: #showInfectionHistory:! !

!BouncingAtomsMorph methodsFor: 'submorphs-add/remove' stamp: ''!
addMorphFront: aMorph 
	(aMorph isMemberOf: AtomMorph)
		ifTrue: [super addMorphFront: aMorph]
		ifFalse: [super addMorphBack: aMorph]! !

!BouncingAtomsMorph methodsFor: 'drawing' stamp: ''!
areasRemainingToFill: aRectangle 
	color isTranslucent
		ifTrue: [^ Array with: aRectangle].
	^ aRectangle areasOutside: self bounds! !

!BouncingAtomsMorph methodsFor: 'other' stamp: ''!
collisionPairs
	| count sortedAtoms radius twoRadii radiiSquared collisions p1 continue j p2 distSquared m1 m2 |
	count := submorphs size.
	sortedAtoms := submorphs
				asSortedCollection: [:mt1 :mt2 | mt1 position x < mt2 position x].
	radius := 8.
	twoRadii := 2 * radius.
	radiiSquared := radius squared * 2.
	collisions := OrderedCollection new.
	1
		to: count - 1
		do: [:i | 
			m1 := sortedAtoms at: i.
			p1 := m1 position.
			continue := (j := i + 1) <= count.
			[continue]
				whileTrue: [m2 := sortedAtoms at: j.
					p2 := m2 position.
					continue := p2 x - p1 x <= twoRadii
								and: [distSquared := (p1 x - p2 x) squared + (p1 y - p2 y) squared.
									distSquared < radiiSquared
										ifTrue: [collisions
												add: (Array with: m1 with: m2)].
									(j := j + 1) <= count]]].
	^ collisions! !

!BouncingAtomsMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color
		r: 0.8
		g: 1.0
		b: 0.8! !

!BouncingAtomsMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	| s e |
	super drawOn: aCanvas.
	damageReported := false.
	aCanvas drawString: self submorphs size asString at: self bounds topLeft! !

!BouncingAtomsMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	damageReported := false.
	self extent: 400 @ 250.
	infectionHistory := OrderedCollection new.
	transmitInfection := false.
	self addAtoms: 30! !

!BouncingAtomsMorph methodsFor: 'initialization' stamp: ''!
intoWorld: aWorld 
	damageReported := false.
	super intoWorld: aWorld! !

!BouncingAtomsMorph methodsFor: 'change reporting' stamp: ''!
invalidRect: damageRect from: aMorph 
	| quickRedraw |
	quickRedraw := true.
	(quickRedraw
			and: [bounds origin <= damageRect topLeft
					and: [damageRect bottomRight <= bounds corner]])
		ifTrue: [damageReported
				ifFalse: [super invalidRect: bounds from: self].
			damageReported := true]
		ifFalse: [super invalidRect: damageRect from: aMorph]! !

!BouncingAtomsMorph methodsFor: 'menu' stamp: ''!
setAtomCount
	| countString count |
	countString := UIManager default request: 'Number of atoms?' translated initialAnswer: self submorphCount printString.
	countString isEmptyOrNil
		ifTrue: [^ self].
	count := Integer
				readFrom: (ReadStream on: countString).
	self removeAllMorphs.
	self addAtoms: count! !

!BouncingAtomsMorph methodsFor: 'other' stamp: ''!
showInfectionHistory: evt 
	| graph |
	infectionHistory isEmpty
		ifTrue: [^ self].
	graph := GraphMorph new data: infectionHistory.
	graph extent: infectionHistory size + (2 * graph borderWidth) + 5
			@ (infectionHistory last max: 50).
	evt hand attachMorph: graph! !

!BouncingAtomsMorph methodsFor: 'menu' stamp: ''!
startInfection
	self
		submorphsDo: [:m | m infected: false].
	self firstSubmorph infected: true.
	infectionHistory := OrderedCollection new: 500.
	transmitInfection := true.
	self startStepping! !

!BouncingAtomsMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	| r temps1 temps2 bounces |
	super step.
	bounces := 0.
	ndAtom
		ifNil: [ndAtom := 30].
	validAtom
		ifNil: [validAtom := 1].
	temps
		ifNil: [temps := DateAndTime now].
	tempsAtom
		ifNil: [tempsAtom := DateAndTime now].
	r := bounds origin corner: bounds corner - (8 @ 8).
	self
		submorphsDo: [:m | (m isMemberOf: AtomMorph)
				ifTrue: [(m bounceIn: r)
						ifTrue: [bounces := bounces + 1]]].
	self updateTemperature: 10000.0 * bounces / (r width + r height).
	transmitInfection
		ifTrue: [self transmitInfection].
	temps1 := (DateAndTime now - temps) asSeconds.
	temps1 > 2
		ifTrue: [self color: Color random.
			temps := nil].
	temps2 := (DateAndTime now - tempsAtom) asSeconds.
	temps2 > 1
		ifTrue: [validAtom = 1
				ifTrue: [submorphs size < 30
						ifTrue: [self addAtoms: 1]
						ifFalse: [validAtom := 0]]
				ifFalse: [submorphs size > 0
						ifTrue: [self removeMorph: submorphs atRandom]
						ifFalse: [validAtom := 1]].
			tempsAtom := nil]! !

!BouncingAtomsMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 0! !

!BouncingAtomsMorph methodsFor: 'other' stamp: ''!
transmitInfection
	| infected count |
	self collisionPairs
		do: [:pair | 
			infected := false.
			pair
				do: [:atom | atom infected
						ifTrue: [infected := true]].
			infected
				ifTrue: [pair
						do: [:atom | atom infected: true]]].
	count := 0.
	self
		submorphsDo: [:m | m infected
				ifTrue: [count := count + 1]].
	infectionHistory addLast: count.
	count = submorphs size
		ifTrue: [transmitInfection := false.
			self stopStepping]! !

!BouncingAtomsMorph methodsFor: 'other' stamp: ''!
updateTemperature: currentTemperature 
	recentTemperatures isNil
		ifTrue: [recentTemperatures := OrderedCollection new.
			20
				timesRepeat: [recentTemperatures add: 0]].
	recentTemperatures removeLast.
	recentTemperatures addFirst: currentTemperature.
	temperature := recentTemperatures sum asFloat / recentTemperatures size! !

Morph subclass: #BouncingCrossMorph
	instanceVariableNames: 'damageReported infectionHistory transmitInfection recentTemperatures temperature temps tempsAtom ndAtom validAtom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphExamplesAndDemos'!

!BouncingCrossMorph class methodsFor: 'parts bin' stamp: ''!
descriptionForPartsBin
	^ self
		partName: 'BouncingAtoms'
		categories: #('Demo' )
		documentation: 'The original, intensively-optimized bouncing-atoms simulation by John Maloney'! !

!BouncingCrossMorph class methodsFor: 'initialization' stamp: ''!
initialize
	self registerInFlapsRegistry! !

!BouncingCrossMorph class methodsFor: 'initialization' stamp: ''!
registerInFlapsRegistry
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(#BouncingAtomsMorph #new 'Bouncing Atoms' 'Atoms, mate' ) forFlapNamed: 'Widgets']! !

!BouncingCrossMorph class methodsFor: 'initialization' stamp: ''!
unload
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!BouncingCrossMorph methodsFor: 'other' stamp: ''!
addAtoms: n 
	| a |
	n
		timesRepeat: [a := CrossMorph new.
			a randomPositionIn: bounds maxVelocity: 5.
			self addMorph: a]! !

!BouncingCrossMorph methodsFor: 'menu' stamp: ''!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'startInfection' translated action: #startInfection.
	aCustomMenu add: 'set atom count' translated action: #setAtomCount.
	aCustomMenu add: 'show infection history' translated action: #showInfectionHistory:! !

!BouncingCrossMorph methodsFor: 'submorphs-add/remove' stamp: ''!
addMorphFront: aMorph 
	(aMorph isMemberOf: CrossMorph)
		ifTrue: [super addMorphFront: aMorph]
		ifFalse: [super addMorphBack: aMorph]! !

!BouncingCrossMorph methodsFor: 'drawing' stamp: ''!
areasRemainingToFill: aRectangle 
	color isTranslucent
		ifTrue: [^ Array with: aRectangle].
	^ aRectangle areasOutside: self bounds! !

!BouncingCrossMorph methodsFor: 'other' stamp: ''!
collisionPairs
	| count sortedAtoms radius twoRadii radiiSquared collisions p1 continue j p2 distSquared m1 m2 |
	count := submorphs size.
	sortedAtoms := submorphs
				asSortedCollection: [:mt1 :mt2 | mt1 position x < mt2 position x].
	radius := 8.
	twoRadii := 2 * radius.
	radiiSquared := radius squared * 2.
	collisions := OrderedCollection new.
	1
		to: count - 1
		do: [:i | 
			m1 := sortedAtoms at: i.
			p1 := m1 position.
			continue := (j := i + 1) <= count.
			[continue]
				whileTrue: [m2 := sortedAtoms at: j.
					p2 := m2 position.
					continue := p2 x - p1 x <= twoRadii
								and: [distSquared := (p1 x - p2 x) squared + (p1 y - p2 y) squared.
									distSquared < radiiSquared
										ifTrue: [collisions
												add: (Array with: m1 with: m2)].
									(j := j + 1) <= count]]].
	^ collisions! !

!BouncingCrossMorph methodsFor: 'initialization' stamp: ''!
defaultColor
	^ Color
		r: 0.8
		g: 1.0
		b: 0.8! !

!BouncingCrossMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas 
	| s e |
	super drawOn: aCanvas.
	damageReported := false.
	aCanvas drawString: self submorphs size asString at: self bounds topLeft! !

!BouncingCrossMorph methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	damageReported := false.
	self extent: 400 @ 250.
	infectionHistory := OrderedCollection new.
	transmitInfection := false.
	self addAtoms: 30! !

!BouncingCrossMorph methodsFor: 'initialization' stamp: ''!
intoWorld: aWorld 
	damageReported := false.
	super intoWorld: aWorld! !

!BouncingCrossMorph methodsFor: 'change reporting' stamp: ''!
invalidRect: damageRect from: aMorph 
	| quickRedraw |
	quickRedraw := true.
	(quickRedraw
			and: [bounds origin <= damageRect topLeft
					and: [damageRect bottomRight <= bounds corner]])
		ifTrue: [damageReported
				ifFalse: [super invalidRect: bounds from: self].
			damageReported := true]
		ifFalse: [super invalidRect: damageRect from: aMorph]! !

!BouncingCrossMorph methodsFor: 'menu' stamp: ''!
setAtomCount
	| countString count |
	countString := UIManager default request: 'Number of atoms?' translated initialAnswer: self submorphCount printString.
	countString isEmptyOrNil
		ifTrue: [^ self].
	count := Integer
				readFrom: (ReadStream on: countString).
	self removeAllMorphs.
	self addAtoms: count! !

!BouncingCrossMorph methodsFor: 'other' stamp: ''!
showInfectionHistory: evt 
	| graph |
	infectionHistory isEmpty
		ifTrue: [^ self].
	graph := GraphMorph new data: infectionHistory.
	graph extent: infectionHistory size + (2 * graph borderWidth) + 5
			@ (infectionHistory last max: 50).
	evt hand attachMorph: graph! !

!BouncingCrossMorph methodsFor: 'menu' stamp: ''!
startInfection
	self
		submorphsDo: [:m | m infected: false].
	self firstSubmorph infected: true.
	infectionHistory := OrderedCollection new: 500.
	transmitInfection := true.
	self startStepping! !

!BouncingCrossMorph methodsFor: 'stepping and presenter' stamp: ''!
step
	| r temps1 temps2 bounces |
	super step.
	bounces := 0.
	ndAtom
		ifNil: [ndAtom := 30].
	validAtom
		ifNil: [validAtom := 1].
	temps
		ifNil: [temps := DateAndTime now].
	tempsAtom
		ifNil: [tempsAtom := DateAndTime now].
	r := bounds origin corner: bounds corner - (20 @ 20).
	self
		submorphsDo: [:m | (m isMemberOf: CrossMorph)
				ifTrue: [(m bounceIn: r)
						ifTrue: [bounces := bounces + 1]]].
	self updateTemperature: 10000.0 * bounces / (r width + r height).
	transmitInfection
		ifTrue: [self transmitInfection].
	temps1 := (DateAndTime now - temps) asSeconds.
	temps1 > 2
		ifTrue: [self color: Color random.
			temps := nil].
	temps2 := (DateAndTime now - tempsAtom) asSeconds.
	temps2 > 1
		ifTrue: [validAtom = 1
				ifTrue: [submorphs size < 30
						ifTrue: [self addAtoms: 1]
						ifFalse: [validAtom := 0]]
				ifFalse: [submorphs size > 0
						ifTrue: [self removeMorph: submorphs atRandom]
						ifFalse: [validAtom := 1]].
			tempsAtom := nil]! !

!BouncingCrossMorph methodsFor: 'testing' stamp: ''!
stepTime
	^ 0! !

!BouncingCrossMorph methodsFor: 'other' stamp: ''!
transmitInfection
	| infected count |
	self collisionPairs
		do: [:pair | 
			infected := false.
			pair
				do: [:atom | atom infected
						ifTrue: [infected := true]].
			infected
				ifTrue: [pair
						do: [:atom | atom infected: true]]].
	count := 0.
	self
		submorphsDo: [:m | m infected
				ifTrue: [count := count + 1]].
	infectionHistory addLast: count.
	count = submorphs size
		ifTrue: [transmitInfection := false.
			self stopStepping]! !

!BouncingCrossMorph methodsFor: 'other' stamp: ''!
updateTemperature: currentTemperature 
	recentTemperatures isNil
		ifTrue: [recentTemperatures := OrderedCollection new.
			20
				timesRepeat: [recentTemperatures add: 0]].
	recentTemperatures removeLast.
	recentTemperatures addFirst: currentTemperature.
	temperature := recentTemperatures sum asFloat / recentTemperatures size! !
ClockMorph initialize!
StickyPadMorph initialize!
StarMorph initialize!
MovingEyeMorph initialize!
BouncingCrossMorph initialize!
AnimatedImageMorph initialize!
BouncingAtomsMorph initialize!
FrameRateMorph initialize!
